define([
      "dojo/_base/declare",
      "dojox/mvc/getPlainValue",
      "dojox/mvc/at",
      "dojox/mvc/getStateful",
      "dojo/when",

      "aps/View",
      "aps/ResourceStore"
   ],
   function (
      declare,
      getPlainValue,
      at,
      getStateful,
      when,

      View,
      Store
   ) {
	return declare(View, {
         init: function() {

			/* Declare the data sources */
			this.vpsModel = getStateful({
				"aps": {
					"type": "http://aps-standard.org/samples/starter1p/vps/1.0"
				},
				"name": ""
			});

			/* Define and return widgets */
			return ["aps/Panel", {
					id: "srvNew1_form"
				}, [
					["aps/FieldSet", {
							title: "General"
						},[
							["aps/TextBox", {
							label: "Server Name",
							value: at(this.vpsModel, "name"),
							required: true
							}]
					]]
			]];

         },		// End of Init

		/* Create handlers for the navigation buttons */

		onCancel: function() {
			aps.apsc.gotoView("servers");
		},

		onSubmit: function() {
			aps.context.subscriptionId = aps.context.vars.management.aps.subscription;
			
			var vpsStore = new Store({
				apsType: "http://aps-standard.org/samples/starter1p/vps/1.0",
				target: "/aps/2/resources/" + aps.context.vars.management.aps.id + "/vpses"
			});
			when(vpsStore.put(getPlainValue(this.vpsModel)),
				function() {
					aps.apsc.gotoView("servers");
				}
			);
		}

      });    // End of Declare
   });        // End of Define
